#import "ObjCViewController.h"
#import "PebbleKit/PebbleKit.h"

static NSString *accelAppUuid = @"ddf1813a-940d-4fc1-9d19-c0b384ddd3c5";

@interface ViewController () <PBPebbleCentralDelegate>

@property PBWatch *watch;

@property (weak, nonatomic) IBOutlet UISlider *Red1;

@property (weak, nonatomic) IBOutlet UISlider *Green1;

@property (weak, nonatomic) IBOutlet UISlider *Blue1;

@property (weak, nonatomic) IBOutlet UISlider *Red2;

@property (weak, nonatomic) IBOutlet UISlider *Green2;

@property (weak, nonatomic) IBOutlet UISlider *Blue2;

@property (weak, nonatomic) IBOutlet UITextField *ChanTxt;

@property (weak, nonatomic) IBOutlet UITextField *ValTxt;

@property (weak, nonatomic) IBOutlet UISlider *ValS;

@property (weak, nonatomic) IBOutlet UIStepper *ValStep;

@property (weak, nonatomic) IBOutlet UIStepper *ChanStep;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [_ChanTxt setDelegate:self];
    [_ValTxt setDelegate:self];
    [[PBPebbleCentral defaultCentral] setDelegate:self];
    [self configureForUUID:accelAppUuid];
    self.watch = [[PBPebbleCentral defaultCentral] lastConnectedWatch];
    if(self.watch) {
        [self.watch appMessagesGetIsSupported:^(PBWatch *watch, BOOL isAppMessagesSupported) {
            if (isAppMessagesSupported) {
                [self sendData:(0) :(0)];
            } else {
            }
        }];
    }
}

- (void)viewDidAppear:(BOOL)animated {
}

- (void)configureForUUID:(NSString *)uuidString{
    uuid_t appUUIDbytes;
    NSUUID *appUUID = [[NSUUID alloc]initWithUUIDString:uuidString];
    [appUUID getUUIDBytes:appUUIDbytes];
    [[PBPebbleCentral defaultCentral] setAppUUID:[NSData dataWithBytes:appUUIDbytes length:16]];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)sendData:(int)channel:(int)value {
    NSMutableDictionary *outgoing = [NSMutableDictionary new];
    NSNumber *intensity = @(value);
    [outgoing setObject:intensity forKey:@(channel)];
    [self.watch appMessagesPushUpdate:outgoing onSent:^(PBWatch *watch, NSDictionary *update, NSError *error) {
    }];
    
}

#pragma mark - SliderAccess



#pragma mark - Sliders

int lastSend = 0;
int lastChan = 0;

- (IBAction)RedChange:(id)sender {
    int thisChan = 1;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

- (IBAction)GreenChange:(id)sender {
    int thisChan = 2;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

- (IBAction)BlueChange:(id)sender {
    int thisChan = 3;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

- (IBAction)RedChange2:(id)sender {
    int thisChan = 4;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

- (IBAction)GreenChage2:(id)sender {
    int thisChan = 5;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

- (IBAction)BlueChange2:(id)sender {
    int thisChan = 6;
    if(lastChan != thisChan || (int)[(UISlider *)sender value] != lastSend){
        [self sendData:thisChan :(int)[(UISlider *)sender value]];
        lastSend = (int) [(UISlider *)sender value];
        lastChan = thisChan;
    }
}

#pragma mark - OFF

- (IBAction)RedOff:(id)sender {
    [self sendData:1 :0];
    [[self Red1] setValue:0];
}

- (IBAction)GreenOff:(id)sender {
    [self sendData:2 :0];
    [[self Green1] setValue:0];
}

- (IBAction)BlueOff:(id)sender {
    [self sendData:3 :0];
    [[self Blue1] setValue:0];
}

- (IBAction)RedOff2:(id)sender {
    [self sendData:4 :0];
    [[self Red2] setValue:0];
}

- (IBAction)GreenOff2:(id)sender {
    [self sendData:5 :0];
    [[self Green2] setValue:0];
}

- (IBAction)BlueOff2:(id)sender {
    [self sendData:6 :0];
    [[self Blue2] setValue:0];
}

#pragma mark - FULL

- (IBAction)RedFull:(id)sender {
    [self sendData:1 :255];
    [[self Red1] setValue:255];
}

- (IBAction)GreenFull:(id)sender {
    [self sendData:2 :255];
    [[self Green1] setValue:255];
}

- (IBAction)BlueFull:(id)sender {
    [self sendData:3 :255];
    [[self Blue1] setValue:255];
}

- (IBAction)RedFull2:(id)sender {
    [self sendData:4 :255];
    [[self Red2] setValue:255];
}

- (IBAction)GreenFull2:(id)sender {
    [self sendData:5 :255];
    [[self Green2] setValue:255];
}

- (IBAction)BlueFull2:(id)sender {
    [self sendData:6 :255];
    [[self Blue2] setValue:255];
}

#pragma mark - settings

- (IBAction)ChanStep:(id)sender {
    [_ChanTxt setText:[NSString stringWithFormat:@"%d", (int)[(UIStepper *)sender value] ]];
}

- (IBAction)ValSlide:(id)sender {
    [_ValTxt setText:[NSString stringWithFormat:@"%d", (int)[(UISlider *)sender value] ]];
    [_ValStep setValue:[(UISlider *)sender value]];

}

- (IBAction)ValStep:(id)sender {
    [_ValTxt setText:[NSString stringWithFormat:@"%d", (int)[(UIStepper *)sender value] ]];
    [_ValS setValue:[(UIStepper *)sender value]];

}

- (BOOL)textFieldShouldReturn:(UITextField*)textField{
    [textField resignFirstResponder];
    return false;
}

- (IBAction)Send:(id)sender {
    [self sendData:[_ValStep value] : [_ChanStep value]];
}

@end
